/*
 * File: Geometry.i
 *
 * Geometry module specific to Lua
 */

%extend te::gm::Geometry {
  static te::gm::MultiLineString* toMultiLineString(Geometry* geom)
  {
    return dynamic_cast<te::gm::MultiLineString*>(geom);
  }

  static te::gm::LineString* toLineString(Geometry* geom)
  {
    return dynamic_cast<te::gm::LineString*>(geom);
  }

  static te::gm::MultiPolygon* toMultiPolygon(Geometry* geom)
  {
    return dynamic_cast<te::gm::MultiPolygon*>(geom);
  }

  static te::gm::Line* toLine(Geometry* geom)
  {
    return dynamic_cast<te::gm::Line*>(geom);
  }

  static te::gm::Point* toPoint(Geometry* geom)
  {
    return dynamic_cast<te::gm::Point*>(geom);
  }

  static te::gm::Polygon* toPolygon(Geometry* geom)
  {
    return dynamic_cast<te::gm::Polygon*>(geom);
  }

  static te::gm::MultiPoint* toMultiPoint(Geometry* geom)
  {
    return dynamic_cast<te::gm::MultiPoint*>(geom);
  }

  static te::gm::CircularString* toCircularString(Geometry* geom)
  {
    return dynamic_cast<te::gm::CircularString*>(geom);
  }

  static te::gm::CompoundCurve* toCompoundCurve(Geometry* geom)
  {
    return dynamic_cast<te::gm::CompoundCurve*>(geom);
  }

  static te::gm::CurvePolygon* toCurvePolygon(Geometry* geom)
  {
    return dynamic_cast<te::gm::CurvePolygon*>(geom);
  }

  static te::gm::GeometryCollection* toGeometryCollection(Geometry* geom)
  {
    return dynamic_cast<te::gm::GeometryCollection*>(geom);
  }

  static te::gm::MultiSurface* toMultiSurface(Geometry* geom)
  {
    return dynamic_cast<te::gm::MultiSurface*>(geom);
  }

  static te::gm::PolyhedralSurface* toPolyhedralSurface(Geometry* geom)
  {
    return dynamic_cast<te::gm::PolyhedralSurface*>(geom);
  }

  static te::gm::TIN* toTIN(Geometry* geom)
  {
    return dynamic_cast<te::gm::TIN*>(geom);
  }

  static te::gm::Triangle* toTriangle(Geometry* geom)
  {
    return dynamic_cast<te::gm::Triangle*>(geom);
  }
};

%extend te::gm::MultiLineString {
  te::gm::MultiLineString* clone()
  {
    return dynamic_cast<te::gm::MultiLineString*>($self->clone());
  }
};

%extend te::gm::LineString {
  te::gm::LineString* clone()
  {
    return dynamic_cast<te::gm::LineString*>($self->clone());
  }
};

%extend te::gm::Point {
  te::gm::Point* clone()
  {
    return dynamic_cast<te::gm::Point*>($self->clone());
  }
};
